---
product: "AG Grid"
title: "Key Features"
description: "Overview of popular AG Grid features with code snippets. Learn how to use key Community features, customise themes and explore advanced Enterprise features."
framework: javascript
version: "36.2.0"
related:
    - title: "Quick Start"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/getting-started/"
    - title: "Community vs. Enterprise"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/community-vs-enterprise/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Key Features

The page provides an overview of and introduction to popular features available in AG Grid. Learn how to use Community features, configure and customise themes, and explore advanced Enterprise features.

[JavaScript Data Grid quick start video tutorial](https://www.youtube.com/watch?v=Ww7-LC6rU6U&list=PLsZlhayVgqNxijfRQxg5Mc6W4MzZHQ9MK)

> **Note**
>
> The following sections assume a level of familiarity with common Data Grid concepts. If you're new to JavaScript Data Grids in general, we recommend starting with our [Introductory Tutorial](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/deep-dive/) instead.

## Showing Data

### Mapping Values

The `field` or `valueGetter` attributes [Map Data to Columns](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-definitions/). A field maps to a field in the data. A [Value Getter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/value-getters/) is a function callback that returns the cell value.

The `headerName` provides the title for the header. If missing the title is derived from `field`.

```js
const gridOptions = {
    columnDefs: [
        { headerName: "Make & Model", valueGetter: p => p.data.make + ' ' + p.data.model},
        { field: "price" },
    ],

    // other grid options ...
}
```

### Text Formatting

Format text for cell content using a [Value Formatter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/value-formatters/).

```js
const gridOptions = {
    columnDefs: [
        { field: "price", valueFormatter: p => '£' + p.value.toLocaleString() },
    ],

    // other grid options ...
}
```

### Cell Components

Add buttons, checkboxes or images to cells with a [Cell Component](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/component-cell-renderer/).

```js
class CustomButtonComponent {
    eGui;
    eButton;
    eventListener;

    init(params) {
        this.eGui = document.createElement("div");
        this.eButton = document.createElement("button");
        this.eButton.className = "btn-simple";
        this.eButton.textContent = "Push Me!";
        this.eventListener = () => console.log("clicked");
        this.eButton.addEventListener("click", this.eventListener);
        this.eGui.appendChild(this.eButton);
    }

    getGui() {
        return this.eGui;
    }

    refresh(params) {
        return true;
    }

    destroy() {
        if (this.eButton) {
            this.eButton.removeEventListener("click", this.eventListener);
        }
    }
}


const columnDefs = [
    { field: "button", cellRenderer: CustomButtonComponent },
    // ...
];
```

### Resizing Columns

Columns are [Resized](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-sizing/) by dragging the Column Header edges. Additionally assign `flex` values to allow columns to flex to the grid width.

```js
const gridOptions = {
    columnDefs: [
        { field: "make", flex: 2 }, //This column will be twice as wide as the others
        { field: "model", flex: 1 },
        { field: "price", flex: 1 },
        { field: "electric", flex: 1 }
    ],

    // other grid options ...
}
```

### Example

This example demonstrates mapping and formatting values, cell components, and resizing columns. The button logs to the developer console.

#### Showing Data Example

```ts
import {
  AllCommunityModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  ValueGetterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);
let gridApi: GridApi;

class CustomButtonComponent {
  eGui!: HTMLDivElement;
  eButton: any;
  eventListener!: () => void;

  init() {
    this.eGui = document.createElement("div");
    this.eButton = document.createElement("button");
    this.eButton.className = "btn-simple";
    this.eButton.textContent = "Push Me!";
    this.eventListener = () => console.log("clicked");
    this.eButton.addEventListener("click", this.eventListener);
    this.eGui.appendChild(this.eButton);
  }

  getGui() {
    return this.eGui;
  }

  refresh() {
    return true;
  }

  destroy() {
    if (this.eButton) {
      this.eButton.removeEventListener("click", this.eventListener);
    }
  }
}

const gridOptions: GridOptions = {
  // Data to be displayed
  rowData: [
    { make: "Tesla", model: "Model Y", price: 64950, electric: true },
    { make: "Ford", model: "F-Series", price: 33850, electric: false },
    { make: "Toyota", model: "Corolla", price: 29600, electric: false },
    { make: "Mercedes", model: "EQA", price: 48890, electric: true },
    { make: "Fiat", model: "500", price: 15774, electric: false },
    { make: "Nissan", model: "Juke", price: 20675, electric: false },
  ],
  // Columns to be displayed (Should match rowData properties)
  columnDefs: [
    {
      headerName: "Make & Model",
      valueGetter: (p: ValueGetterParams) => p.data.make + " " + p.data.model,
      flex: 2,
    },
    {
      field: "price",
      valueFormatter: (p) => "£" + Math.floor(p.value).toLocaleString(),
      flex: 1,
    },
    { field: "electric", flex: 1 },
    { field: "button", cellRenderer: CustomButtonComponent, flex: 1 },
  ],
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Showing Data Example](https://www.ag-grid.com/archive/36.2.0/examples/key-features/showing-data-example/typescript/)

## Working with Data

By default, the row data is used to infer the [Cell Data Type](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-data-types/). The cell data type allows grid features, such as filtering and editing, to work without additional configuration.

### Filtering

[Column Filters](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filtering/) are embedded into each column menu. These are enabled using the `filter` attribute. The filter type is inferred from the cell data type.

```js
const gridOptions = {
    columnDefs: [
        { field: "make", filter: true },
    ],

    // other grid options ...
}
```

There are 5 [Provided Filters](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filtering/) which can be set through this attribute. You can also create your own [Custom Filter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/component-filter/).

[Floating Filters](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/floating-filters/) embed the Column Filter into the header for ease of access.

```js
const gridOptions = {
    columnDefs: [
        { field: "make", filter: true, floatingFilter: true },
    ],

    // other grid options ...
}
```

### Editing

Enable [Editing](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editing/) by setting the `editable` attribute to `true`. The cell editor is inferred from the cell data type.

```js
const gridOptions = {
    columnDefs: [
        { field: "make", editable: true },
    ],

    // other grid options ...
}
```

Set the cell editor type using the `cellEditor` attribute. There are 8 [Provided Cell Editors](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/provided-cell-editors/) which can be set through this attribute. You can also create your own [Custom Editors](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-editors/).

```js
const gridOptions = {
    columnDefs: [
        {
            field: "make",
            editable: true,
            cellEditor: 'agSelectCellEditor',
            cellEditorParams: {
                values: ['Tesla', 'Ford', 'Toyota'],
            },
        },
    ],

    // other grid options ...
}
```

### Sorting

Data is [Sorted](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-sorting/) by clicking the column headers. Sorting is enabled by default.

### Row Selection

[Row Selection](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-selection/) is enabled using the `rowSelection` attribute.

```js
const gridOptions = {
    // Column Definitions: Defines the columns to be displayed.
    columnDefs: [
        { field: "make" },
    ],
    rowSelection: {
        mode: 'multiRow',
    },

    // other grid options ...
}
```

### Pagination

Enable [Pagination](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-pagination/) by setting `pagination` to be true.

```js
const gridOptions = {
    pagination: true,
    paginationPageSize: 10,
    paginationPageSizeSelector: [10, 25, 50],

    // other grid options ...
}
```

### Example

This example demonstrates filtering, editing, sorting, row selection, and pagination.

#### Working With Data Example

```ts
import {
  AllCommunityModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

const gridOptions: GridOptions = {
  rowData: [
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
  ],
  columnDefs: [
    {
      field: "make",
      editable: true,
      cellEditor: "agSelectCellEditor",
      cellEditorParams: {
        values: [
          "Tesla",
          "Ford",
          "Toyota",
          "Mercedes",
          "Fiat",
          "Nissan",
          "Vauxhall",
          "Volvo",
          "Jaguar",
        ],
      },
    },
    { field: "model" },
    { field: "price", filter: "agNumberColumnFilter" },
    { field: "electric" },
    {
      field: "month",
      comparator: (valueA, valueB) => {
        const months = [
          "January",
          "February",
          "March",
          "April",
          "May",
          "June",
          "July",
          "August",
          "September",
          "October",
          "November",
          "December",
        ];
        const idxA = months.indexOf(valueA);
        const idxB = months.indexOf(valueB);
        return idxA - idxB;
      },
    },
  ],
  defaultColDef: {
    filter: "agTextColumnFilter",
    floatingFilter: true,
  },
  rowSelection: {
    mode: "multiRow",
    headerCheckbox: false,
  },
  pagination: true,
  paginationPageSize: 10,
  paginationPageSizeSelector: [10, 25, 50],
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
const gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Working With Data Example](https://www.ag-grid.com/archive/36.2.0/examples/key-features/working-with-data-example/typescript/)

## Themes & Style

### Themes

[Grid Themes](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming/) define how the grid looks (colours, font, spacing etc). The default theme is called Quartz. You can choose a [different theme](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/themes/), or customise a built-in theme by changing parameters. Here we create a new theme based on Quartz:

```js
import { themeQuartz } from "ag-grid-community"; // or themeBalham, themeAlpine

const myTheme = themeQuartz.withParams({
    /* Low spacing = very compact */
    spacing: 2,
    /* Changes the colour of the grid text */
    foregroundColor: 'rgb(14, 68, 145)',
    /* Changes the colour of the grid background */
    backgroundColor: 'rgb(241, 247, 255)',
    /* Changes the header colour of the top row */
    headerBackgroundColor: 'rgb(228, 237, 250)',
    /* Changes the hover colour of the row*/
    rowHoverColor: 'rgb(216, 226, 255)',
});

const gridOptions = {
    theme: myTheme,
    ...
}
```

#### Customising Quartz Theme

```ts
import {
  AllCommunityModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
  themeQuartz,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);
const myTheme = themeQuartz.withParams({
  /* Low spacing = very compact */
  spacing: 2,
  /* Changes the colour of the grid text */
  foregroundColor: "rgb(14, 68, 145)",
  /* Changes the colour of the grid background */
  backgroundColor: "rgb(241, 247, 255)",
  /* Changes the header colour of the top row */
  headerBackgroundColor: "rgb(228, 237, 250)",
  /* Changes the hover colour of the row*/
  rowHoverColor: "rgb(216, 226, 255)",
});

const columnDefs: ColDef[] = [
  { field: "athlete", minWidth: 170 },
  { field: "age" },
  { field: "country" },
  { field: "year" },
  { field: "date" },
  { field: "sport" },
  { field: "gold" },
  { field: "silver" },
  { field: "bronze" },
  { field: "total" },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  theme: myTheme,
  rowData: null,
  columnDefs: columnDefs,
  defaultColDef: {
    editable: true,
    filter: true,
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Customising Quartz Theme](https://www.ag-grid.com/archive/36.2.0/examples/key-features/custom-quartz-theme/typescript/)

### Theme Builder

Use the [Theme Builder](https://www.ag-grid.com/archive/36.2.0/theme-builder/) to create a custom theme with our visual editor. Browse and customise 100's of theme parameters and preview the changes in real-time. Automatically generate the theme code to copy & paste into your application.

[Video](https://www.ag-grid.com/archive/36.2.0/_astro/theme-builder-demo.DqpCSmGG.mp4)

### Figma

If you are designing within Figma, you can use the [AG Grid Design System](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/ag-grid-design-system/) to replicate the Quartz AG Grid theme within Figma. This default theme can be extended with Figma variables to match any existing visual design or create entirely new AG Grid themes. These can then be exported and generated into new AG Grid themes.

[AG Grid Design System (Figma)](https://www.figma.com/community/file/1360600846643230092/ag-grid-design-system)

### Cell Style

Define rules to apply [Styling to Cells](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-styles/) using `cellClassRules`. This can be used, for example, to set cell background colour based on its value.

```css
.rag-green {
    background-color: #33cc3344;
}
```

```js
const gridOptions = {
    columnDefs: [{
        field: 'electric',
        cellClassRules: {
            // apply green to electric cars
            'rag-green': params => params.value === true,
        }
    }],

    // other grid options ...
}
```

### Row Style

Define rules to apply [Styling to Rows](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-styles/) using `rowClassRules`. This allows changing style (e.g. row colour) based on row values.

```css
.rag-red {
    background-color: #cc222244;
}
```

```js
const gridOptions = {
    rowClassRules: {
        // apply red to Ford cars
        'rag-red': params => params.data.make === 'Ford',
    },

    // other grid options ...
}
```

### Example

This example demonstrates cell style and row style.

#### Cell and Row Style

```ts
import {
  AllCommunityModule,
  CellClassRules,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

const ragCellClassRules: CellClassRules = {
  // apply green to electric cars
  "rag-green": (params) => params.value === true,
};

const gridOptions: GridOptions = {
  rowData: [
    { make: "Tesla", model: "Model Y", price: 64950, electric: true },
    { make: "Ford", model: "F-Series", price: 33850, electric: false },
    { make: "Toyota", model: "Corolla", price: 29600, electric: false },
    { make: "Mercedes", model: "EQA", price: 48890, electric: true },
    { make: "Fiat", model: "500", price: 15774, electric: false },
    { make: "Nissan", model: "Juke", price: 20675, electric: false },
    { make: "Vauxhall", model: "Corsa", price: 18460, electric: false },
    { make: "Volvo", model: "EX30", price: 33795, electric: true },
    { make: "Mercedes", model: "Maybach", price: 175720, electric: false },
    { make: "Vauxhall", model: "Astra", price: 25795, electric: false },
    { make: "Fiat", model: "Panda", price: 13724, electric: false },
    { make: "Jaguar", model: "I-PACE", price: 69425, electric: true },
  ],
  columnDefs: [
    {
      field: "make",
    },
    { field: "model" },
    { field: "price", filter: "agNumberColumnFilter" },
    {
      field: "electric",
      cellClassRules: ragCellClassRules,
    },
  ],
  defaultColDef: {
    filter: "agTextColumnFilter",
    floatingFilter: true,
    flex: 1,
  },
  rowClassRules: {
    // apply red to Ford cars
    "rag-red": (params) => params.data.make === "Ford",
  },
  rowSelection: {
    mode: "multiRow",
    headerCheckbox: false,
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
const gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Cell and Row Style](https://www.ag-grid.com/archive/36.2.0/examples/key-features/cell-row-style/typescript/)

## Enterprise Features  (Enterprise)

AG Grid comes in two forms:

- **AG Grid Community**: Free for everyone, including production use - no licence required.
- **AG Grid Enterprise**: Requires a licence to use in production. Free to test locally, or request a [trial](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/community-vs-enterprise/#request-a-30-day-enterprise-bundle-trial-licence) to test in production.

To learn more about the differences between AG Grid Community and Enterprise, when to use each version, and how to access our [free trial](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/community-vs-enterprise/#request-a-30-day-enterprise-bundle-trial-licence) or purchase a licence, see the [Community vs Enterprise](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/community-vs-enterprise/) docs.

### Integrated Charts  (Enterprise)

[Integrated Charts](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/integrated-charts/) allow users to build and customise charts directly within the grid.

Allow users to create Integrated Charts from the grid UI by setting `enableCharts` to `true`. Set `cellSelection` to `true` to allow users to create charts by selecting a range of cells:

```js
const gridOptions = {
    enableCharts: true,
    cellSelection: true,

    // other grid options ...
}
```

### Grouping Rows  (Enterprise)

Enable [Row Grouping](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping/) by setting `rowGroup` to `true`:

```js
const gridOptions = {
    columnDefs: [
        { field: 'country', rowGroup: true },
        // ...
    ],

    // other grid options ...
}
```

### Aggregating Rows  (Enterprise)

Enable [Aggregation](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/aggregation/) by setting `aggFunc` to one of `sum`, `min`, `max`, `count`, `avg`, `first`, or `last`:

```js
const gridOptions = {
    columnDefs: [
        { field: 'gold', aggFunc: 'sum' },
        // ...
    ],

    // other grid options ...
}
```

### Pivoting Rows  (Enterprise)

Enable [Pivoting](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/pivoting/) by setting `pivotMode` to `true`. Define pivot columns by setting `pivot` to `true`:

```js
const gridOptions = {
    columnDefs: [
        { field: 'sport', pivot: true },
    ],
    pivotMode: true,

    // other grid options ...
}
```

### Displaying Tree Data  (Enterprise)

Tree Data provides a way to supply the grid with structured hierarchical data.

Enable Tree Data by setting `treeData` to `true`. Provide a `getDataPath` callback to configure the [Row Hierarchy](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tree-data-paths/#providing-hierarchy):

```js
const gridOptions = {
    treeData: true,
    getDataPath: data => data.path,

    // other grid options ...
}
```

### Displaying Tool Panels  (Enterprise)

The grid provides [Tool Panels](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tool-panel/) for [Columns](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tool-panel-columns/) and [Filters](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tool-panel-filters/). You can also provide [Custom Tool Panels](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/component-tool-panel/).

To enable Column and Filter Tool Panels, set `sideBar` to `true`. To display only the Column or Filter Tool Panel, set `sideBar` to `'columns'` or `'filters'`:

```js
const gridOptions = {
    sideBar: true,

    // other grid options ...
}
```

### Example

This example demonstrates Integrated Charting, Row Grouping, Pivoting, Aggregation and Tool Panels:

#### Enterprise Features

```ts
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
  AllCommunityModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  AllEnterpriseModule,
  IntegratedChartsModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  AllCommunityModule,
  AllEnterpriseModule,
  IntegratedChartsModule.with(AgChartsEnterpriseModule),
]);

const gridOptions: GridOptions = {
  rowData: [
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
  ],
  columnDefs: [
    // Group by 'make', hiding it once grouped
    { field: "make", rowGroup: true, hide: true },
    { field: "model" },
    // Aggregate the average price per group
    { field: "price", filter: "agNumberColumnFilter", aggFunc: "avg" },
    { field: "electric" },
    { field: "month" },
  ],
  defaultColDef: {
    filter: "agTextColumnFilter",
    floatingFilter: true,
    sortable: true,
    resizable: true,
  },
  groupDisplayType: "singleColumn",
  cellSelection: true,
  enableCharts: true,
  onFirstDataRendered: (params) => {
    params.api.createRangeChart({
      cellRange: {
        rowStartIndex: 0,
        rowEndIndex: 8,
        columns: ["model", "price"],
      },
      chartType: "groupedColumn",
      chartThemeOverrides: {
        common: {
          title: {
            enabled: true,
            text: "Average Price by Make",
          },
        },
      },
    });
  },
  sideBar: {
    toolPanels: ["columns", "filters"],
    defaultToolPanel: "columns",
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
const gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Enterprise Features](https://www.ag-grid.com/archive/36.2.0/examples/key-features/enterprise-features-example/typescript/)


---
product: "AG Grid"
title: "Key Features"
description: "Overview of popular AG Grid features with code snippets. Learn how to use key Community features, customise themes and explore advanced Enterprise features."
framework: react
version: "36.2.0"
related:
    - title: "Quick Start"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/getting-started/"
    - title: "Community vs. Enterprise"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/community-vs-enterprise/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Key Features

The page provides an overview of and introduction to popular features available in AG Grid. Learn how to use Community features, configure and customise themes, and explore advanced Enterprise features.

[React Data Grid quick start video tutorial](https://www.youtube.com/watch?v=6hxbPqziELk&list=PLsZlhayVgqNwHNHeqpCkSgdRV08xrKtzW)

> **Note**
>
> The following sections assume a level of familiarity with common Data Grid concepts. If you're new to React Data Grids in general, we recommend starting with our [Introductory Tutorial](https://www.ag-grid.com/archive/36.2.0/react-data-grid/deep-dive/) instead.

## Showing Data

### Mapping Values

The `field` or `valueGetter` attributes [Map Data to Columns](https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-definitions/). A field maps to a field in the data. A [Value Getter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-getters/) is a function callback that returns the cell value.

The `headerName` provides the title for the header. If missing the title is derived from `field`.

```jsx
const [columnDefs, setColumnDefs] = useState([
    { headerName: "Make & Model", valueGetter: p => p.data.make + ' ' + p.data.model},
    { field: "price" },
]);

<AgGridReact columnDefs={columnDefs} />
```

### Text Formatting

Format text for cell content using a [Value Formatter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-formatters/).

```jsx
const [columnDefs, setColumnDefs] = useState([
    { field: "price", valueFormatter: p => '£' + p.value.toLocaleString() },
]);

<AgGridReact columnDefs={columnDefs} />
```

### Cell Components

Add buttons, checkboxes or images to cells with a [Cell Component](https://www.ag-grid.com/archive/36.2.0/react-data-grid/component-cell-renderer/).

```jsx
const CustomButtonComponent = (props) => {
    return <button onClick={() => window.alert('clicked') }>Push Me!</button>;
};

const [colDefs, setColDefs] = useState([
    { field: "button", cellRenderer: CustomButtonComponent },
    // ...
]);
```

### Resizing Columns

Columns are [Resized](https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-sizing/) by dragging the Column Header edges. Additionally assign `flex` values to allow columns to flex to the grid width.

```jsx
const [columnDefs, setColumnDefs] = useState([
    { field: "make", flex: 2 }, //This column will be twice as wide as the others
    { field: "model", flex: 1 },
    { field: "price", flex: 1 },
    { field: "electric", flex: 1 }
]);

<AgGridReact columnDefs={columnDefs} />
```

### Example

This example demonstrates mapping and formatting values, cell components, and resizing columns. The button logs to the developer console.

#### Showing Data Example

```tsx
'use client';
import React, { StrictMode, useState } from "react";
import { createRoot } from "react-dom/client";

import type { ColDef, ColGroupDef, ValueGetterParams } from "ag-grid-community";
import { AllCommunityModule } from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

const CustomButtonComponent = () => {
  return <button onClick={() => console.log("clicked")}>Push Me!</button>;
};

const GridExample = () => {
  const [rowData, setRowData] = useState<any[]>([
    { make: "Tesla", model: "Model Y", price: 64950, electric: true },
    { make: "Ford", model: "F-Series", price: 33850, electric: false },
    { make: "Toyota", model: "Corolla", price: 29600, electric: false },
    { make: "Mercedes", model: "EQA", price: 48890, electric: true },
    { make: "Fiat", model: "500", price: 15774, electric: false },
    { make: "Nissan", model: "Juke", price: 20675, electric: false },
  ]);
  const [columnDefs, setColumnDefs] = useState<
    (ColDef<any, any> | ColGroupDef<any>)[]
  >([
    {
      headerName: "Make & Model",
      valueGetter: (p: ValueGetterParams) => p.data.make + " " + p.data.model,
      flex: 2,
    },
    {
      field: "price",
      valueFormatter: (p) => "£" + Math.floor(p.value).toLocaleString(),
      flex: 1,
    },
    { field: "electric", flex: 1 },
    { field: "button", cellRenderer: CustomButtonComponent, flex: 1 },
  ]);
  return (
    <AgGridProvider modules={[AllCommunityModule]}>
      <div style={{ width: "100%", height: "100%" }}>
        <div style={{ width: "100%", height: "100%" }}>
          <AgGridReact rowData={rowData} columnDefs={columnDefs} />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Showing Data Example](https://www.ag-grid.com/archive/36.2.0/examples/key-features/showing-data-example/reactFunctionalTs/)

## Working with Data

By default, the row data is used to infer the [Cell Data Type](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-data-types/). The cell data type allows grid features, such as filtering and editing, to work without additional configuration.

### Filtering

[Column Filters](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filtering/) are embedded into each column menu. These are enabled using the `filter` attribute. The filter type is inferred from the cell data type.

```jsx
const [columnDefs, setColumnDefs] = useState([
    { field: "make", filter: true },
]);

<AgGridReact columnDefs={columnDefs} />
```

There are 5 [Provided Filters](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filtering/) which can be set through this attribute. You can also create your own [Custom Filter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/component-filter/).

[Floating Filters](https://www.ag-grid.com/archive/36.2.0/react-data-grid/floating-filters/) embed the Column Filter into the header for ease of access.

```jsx
const [columnDefs, setColumnDefs] = useState([
    { field: "make", filter: true, floatingFilter: true },
]);

<AgGridReact columnDefs={columnDefs} />
```

### Editing

Enable [Editing](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing/) by setting the `editable` attribute to `true`. The cell editor is inferred from the cell data type.

```jsx
const [columnDefs, setColumnDefs] = useState([
    { field: "make", editable: true },
]);

<AgGridReact columnDefs={columnDefs} />
```

Set the cell editor type using the `cellEditor` attribute. There are 8 [Provided Cell Editors](https://www.ag-grid.com/archive/36.2.0/react-data-grid/provided-cell-editors/) which can be set through this attribute. You can also create your own [Custom Editors](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editors/).

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: "make",
        editable: true,
        cellEditor: 'agSelectCellEditor',
        cellEditorParams: {
            values: ['Tesla', 'Ford', 'Toyota'],
        },
    },
]);

<AgGridReact columnDefs={columnDefs} />
```

### Sorting

Data is [Sorted](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-sorting/) by clicking the column headers. Sorting is enabled by default.

### Row Selection

[Row Selection](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-selection/) is enabled using the `rowSelection` attribute.

```jsx
// Column Definitions: Defines the columns to be displayed.
const [columnDefs, setColumnDefs] = useState([
    { field: "make" },
]);
const rowSelection = useMemo(() => { 
	return {
        mode: 'multiRow',
    };
}, []);

<AgGridReact
    columnDefs={columnDefs}
    rowSelection={rowSelection}
/>
```

### Pagination

Enable [Pagination](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-pagination/) by setting `pagination` to be true.

```jsx
const pagination = true;
const paginationPageSize = 10;
const paginationPageSizeSelector = [10, 25, 50];

<AgGridReact
    pagination={pagination}
    paginationPageSize={paginationPageSize}
    paginationPageSizeSelector={paginationPageSizeSelector}
/>
```

### Example

This example demonstrates filtering, editing, sorting, row selection, and pagination.

#### Working With Data Example

```tsx
'use client';
import React, { StrictMode, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type { ColDef, RowSelectionOptions } from "ag-grid-community";
import { AllCommunityModule } from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

const rowSelection: RowSelectionOptions = {
  mode: "multiRow",
  headerCheckbox: false,
};

const GridExample = () => {
  const [rowData, setRowData] = useState([
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
  ]);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "make",
      editable: true,
      cellEditor: "agSelectCellEditor",
      cellEditorParams: {
        values: [
          "Tesla",
          "Ford",
          "Toyota",
          "Mercedes",
          "Fiat",
          "Nissan",
          "Vauxhall",
          "Volvo",
          "Jaguar",
        ],
      },
    },
    { field: "model" },
    { field: "price", filter: "agNumberColumnFilter" },
    { field: "electric" },
    {
      field: "month",
      comparator: (valueA: string, valueB: string) => {
        const months = [
          "January",
          "February",
          "March",
          "April",
          "May",
          "June",
          "July",
          "August",
          "September",
          "October",
          "November",
          "December",
        ];
        const idxA = months.indexOf(valueA);
        const idxB = months.indexOf(valueB);
        return idxA - idxB;
      },
    },
  ]);

  const defaultColDef = useMemo(() => {
    return {
      filter: "agTextColumnFilter",
      floatingFilter: true,
    };
  }, []);

  return (
    <AgGridProvider modules={[AllCommunityModule]}>
      <div style={{ height: 500 }}>
        <AgGridReact
          rowData={rowData}
          columnDefs={columnDefs}
          defaultColDef={defaultColDef}
          rowSelection={rowSelection}
          pagination={true}
          paginationPageSize={10}
          paginationPageSizeSelector={[10, 25, 50]}
        />
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Working With Data Example](https://www.ag-grid.com/archive/36.2.0/examples/key-features/working-with-data-example/reactFunctionalTs/)

## Themes & Style

### Themes

[Grid Themes](https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming/) define how the grid looks (colours, font, spacing etc). The default theme is called Quartz. You can choose a [different theme](https://www.ag-grid.com/archive/36.2.0/react-data-grid/themes/), or customise a built-in theme by changing parameters. Here we create a new theme based on Quartz:

```js
import { themeQuartz } from "ag-grid-community"; // or themeBalham, themeAlpine

const myTheme = themeQuartz.withParams({
    /* Low spacing = very compact */
    spacing: 2,
    /* Changes the colour of the grid text */
    foregroundColor: 'rgb(14, 68, 145)',
    /* Changes the colour of the grid background */
    backgroundColor: 'rgb(241, 247, 255)',
    /* Changes the header colour of the top row */
    headerBackgroundColor: 'rgb(228, 237, 250)',
    /* Changes the hover colour of the row*/
    rowHoverColor: 'rgb(216, 226, 255)',
});

...
return (
    <div>
        <AgGridReact theme={myTheme} rowData={...} columnDefs={...} />
    </div>
)
```

#### Customising Quartz Theme

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  useEffect,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AllCommunityModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  Theme,
  enableDevValidations,
  themeQuartz,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [AllCommunityModule];

const myTheme = themeQuartz.withParams({
  /* Low spacing = very compact */
  spacing: 2,
  /* Changes the colour of the grid text */
  foregroundColor: "rgb(14, 68, 145)",
  /* Changes the colour of the grid background */
  backgroundColor: "rgb(241, 247, 255)",
  /* Changes the header colour of the top row */
  headerBackgroundColor: "rgb(228, 237, 250)",
  /* Changes the hover colour of the row*/
  rowHoverColor: "rgb(216, 226, 255)",
});

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 170 },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const theme = useMemo<Theme | "legacy">(() => {
    return myTheme;
  }, []);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      filter: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            ref={gridRef}
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            theme={theme}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Customising Quartz Theme](https://www.ag-grid.com/archive/36.2.0/examples/key-features/custom-quartz-theme/reactFunctionalTs/)

### Theme Builder

Use the [Theme Builder](https://www.ag-grid.com/archive/36.2.0/theme-builder/) to create a custom theme with our visual editor. Browse and customise 100's of theme parameters and preview the changes in real-time. Automatically generate the theme code to copy & paste into your application.

[Video](https://www.ag-grid.com/archive/36.2.0/_astro/theme-builder-demo.DqpCSmGG.mp4)

### Figma

If you are designing within Figma, you can use the [AG Grid Design System](https://www.ag-grid.com/archive/36.2.0/react-data-grid/ag-grid-design-system/) to replicate the Quartz AG Grid theme within Figma. This default theme can be extended with Figma variables to match any existing visual design or create entirely new AG Grid themes. These can then be exported and generated into new AG Grid themes.

[AG Grid Design System (Figma)](https://www.figma.com/community/file/1360600846643230092/ag-grid-design-system)

### Cell Style

Define rules to apply [Styling to Cells](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-styles/) using `cellClassRules`. This can be used, for example, to set cell background colour based on its value.

```css
.rag-green {
    background-color: #33cc3344;
}
```

```jsx
const [columnDefs, setColumnDefs] = useState([{
    field: 'electric',
    cellClassRules: {
        // apply green to electric cars
        'rag-green': params => params.value === true,
    }
}]);

<AgGridReact columnDefs={columnDefs} />
```

### Row Style

Define rules to apply [Styling to Rows](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-styles/) using `rowClassRules`. This allows changing style (e.g. row colour) based on row values.

```css
.rag-red {
    background-color: #cc222244;
}
```

```jsx
const rowClassRules = useMemo(() => { 
	return {
        // apply red to Ford cars
        'rag-red': params => params.data.make === 'Ford',
    };
}, []);

<AgGridReact rowClassRules={rowClassRules} />
```

### Example

This example demonstrates cell style and row style.

#### Cell and Row Style

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  useEffect,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  AllCommunityModule,
  CellClassRules,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowClassRules,
  RowSelectionOptions,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [AllCommunityModule];

const ragCellClassRules: CellClassRules = {
  // apply green to electric cars
  "rag-green": (params) => params.value === true,
};

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>([
    { make: "Tesla", model: "Model Y", price: 64950, electric: true },
    { make: "Ford", model: "F-Series", price: 33850, electric: false },
    { make: "Toyota", model: "Corolla", price: 29600, electric: false },
    { make: "Mercedes", model: "EQA", price: 48890, electric: true },
    { make: "Fiat", model: "500", price: 15774, electric: false },
    { make: "Nissan", model: "Juke", price: 20675, electric: false },
    { make: "Vauxhall", model: "Corsa", price: 18460, electric: false },
    { make: "Volvo", model: "EX30", price: 33795, electric: true },
    { make: "Mercedes", model: "Maybach", price: 175720, electric: false },
    { make: "Vauxhall", model: "Astra", price: 25795, electric: false },
    { make: "Fiat", model: "Panda", price: 13724, electric: false },
    { make: "Jaguar", model: "I-PACE", price: 69425, electric: true },
  ]);
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "make",
    },
    { field: "model" },
    { field: "price", filter: "agNumberColumnFilter" },
    {
      field: "electric",
      cellClassRules: ragCellClassRules,
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      filter: "agTextColumnFilter",
      floatingFilter: true,
      flex: 1,
    };
  }, []);
  const rowClassRules = useMemo<RowClassRules>(() => {
    return {
      // apply red to Ford cars
      "rag-red": (params) => params.data.make === "Ford",
    };
  }, []);
  const rowSelection = useMemo<
    RowSelectionOptions | "single" | "multiple"
  >(() => {
    return {
      mode: "multiRow",
      headerCheckbox: false,
    };
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            ref={gridRef}
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            rowClassRules={rowClassRules}
            rowSelection={rowSelection}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Cell and Row Style](https://www.ag-grid.com/archive/36.2.0/examples/key-features/cell-row-style/reactFunctionalTs/)

## Enterprise Features  (Enterprise)

AG Grid comes in two forms:

- **AG Grid Community**: Free for everyone, including production use - no licence required.
- **AG Grid Enterprise**: Requires a licence to use in production. Free to test locally, or request a [trial](https://www.ag-grid.com/archive/36.2.0/react-data-grid/community-vs-enterprise/#request-a-30-day-enterprise-bundle-trial-licence) to test in production.

To learn more about the differences between AG Grid Community and Enterprise, when to use each version, and how to access our [free trial](https://www.ag-grid.com/archive/36.2.0/react-data-grid/community-vs-enterprise/#request-a-30-day-enterprise-bundle-trial-licence) or purchase a licence, see the [Community vs Enterprise](https://www.ag-grid.com/archive/36.2.0/react-data-grid/community-vs-enterprise/) docs.

### Integrated Charts  (Enterprise)

[Integrated Charts](https://www.ag-grid.com/archive/36.2.0/react-data-grid/integrated-charts/) allow users to build and customise charts directly within the grid.

Allow users to create Integrated Charts from the grid UI by setting `enableCharts` to `true`. Set `cellSelection` to `true` to allow users to create charts by selecting a range of cells:

```jsx
const enableCharts = true;
const cellSelection = true;

<AgGridReact
    enableCharts={enableCharts}
    cellSelection={cellSelection}
/>
```

### Grouping Rows  (Enterprise)

Enable [Row Grouping](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping/) by setting `rowGroup` to `true`:

```jsx
const [columnDefs, setColumnDefs] = useState([
    { field: 'country', rowGroup: true },
    // ...
]);

<AgGridReact columnDefs={columnDefs} />
```

### Aggregating Rows  (Enterprise)

Enable [Aggregation](https://www.ag-grid.com/archive/36.2.0/react-data-grid/aggregation/) by setting `aggFunc` to one of `sum`, `min`, `max`, `count`, `avg`, `first`, or `last`:

```jsx
const [columnDefs, setColumnDefs] = useState([
    { field: 'gold', aggFunc: 'sum' },
    // ...
]);

<AgGridReact columnDefs={columnDefs} />
```

### Pivoting Rows  (Enterprise)

Enable [Pivoting](https://www.ag-grid.com/archive/36.2.0/react-data-grid/pivoting/) by setting `pivotMode` to `true`. Define pivot columns by setting `pivot` to `true`:

```jsx
const [columnDefs, setColumnDefs] = useState([
    { field: 'sport', pivot: true },
]);
const pivotMode = true;

<AgGridReact
    columnDefs={columnDefs}
    pivotMode={pivotMode}
/>
```

### Displaying Tree Data  (Enterprise)

Tree Data provides a way to supply the grid with structured hierarchical data.

Enable Tree Data by setting `treeData` to `true`. Provide a `getDataPath` callback to configure the [Row Hierarchy](https://www.ag-grid.com/archive/36.2.0/react-data-grid/tree-data-paths/#providing-hierarchy):

```jsx
const treeData = true;
const getDataPath = useCallback(data => data.path, []);

<AgGridReact
    treeData={treeData}
    getDataPath={getDataPath}
/>
```

### Displaying Tool Panels  (Enterprise)

The grid provides [Tool Panels](https://www.ag-grid.com/archive/36.2.0/react-data-grid/tool-panel/) for [Columns](https://www.ag-grid.com/archive/36.2.0/react-data-grid/tool-panel-columns/) and [Filters](https://www.ag-grid.com/archive/36.2.0/react-data-grid/tool-panel-filters/). You can also provide [Custom Tool Panels](https://www.ag-grid.com/archive/36.2.0/react-data-grid/component-tool-panel/).

To enable Column and Filter Tool Panels, set `sideBar` to `true`. To display only the Column or Filter Tool Panel, set `sideBar` to `'columns'` or `'filters'`:

```jsx
const sideBar = true;

<AgGridReact sideBar={sideBar} />
```

### Example

This example demonstrates Integrated Charting, Row Grouping, Pivoting, Aggregation and Tool Panels:

#### Enterprise Features

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  useEffect,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
  AllCommunityModule,
  CellSelectionOptions,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  RowGroupingDisplayType,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  AllEnterpriseModule,
  IntegratedChartsModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  AllCommunityModule,
  AllEnterpriseModule,
  IntegratedChartsModule.with(AgChartsEnterpriseModule),
];

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>([
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
  ]);
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    // Group by 'make', hiding it once grouped
    { field: "make", rowGroup: true, hide: true },
    { field: "model" },
    // Aggregate the average price per group
    { field: "price", filter: "agNumberColumnFilter", aggFunc: "avg" },
    { field: "electric" },
    { field: "month" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      filter: "agTextColumnFilter",
      floatingFilter: true,
      sortable: true,
      resizable: true,
    };
  }, []);
  const sideBar = useMemo<
    SideBarDef | string | string[] | boolean | null
  >(() => {
    return {
      toolPanels: ["columns", "filters"],
      defaultToolPanel: "columns",
    };
  }, []);

  const onFirstDataRendered = useCallback((params) => {
    params.api.createRangeChart({
      cellRange: {
        rowStartIndex: 0,
        rowEndIndex: 8,
        columns: ["model", "price"],
      },
      chartType: "groupedColumn",
      chartThemeOverrides: {
        common: {
          title: {
            enabled: true,
            text: "Average Price by Make",
          },
        },
      },
    });
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            ref={gridRef}
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            groupDisplayType={"singleColumn"}
            cellSelection={true}
            enableCharts={true}
            sideBar={sideBar}
            onFirstDataRendered={onFirstDataRendered}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Enterprise Features](https://www.ag-grid.com/archive/36.2.0/examples/key-features/enterprise-features-example/reactFunctionalTs/)


---
product: "AG Grid"
title: "Key Features"
description: "Overview of popular AG Grid features with code snippets. Learn how to use key Community features, customise themes and explore advanced Enterprise features."
framework: angular
version: "36.2.0"
related:
    - title: "Quick Start"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/getting-started/"
    - title: "Community vs. Enterprise"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/community-vs-enterprise/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Key Features

The page provides an overview of and introduction to popular features available in AG Grid. Learn how to use Community features, configure and customise themes, and explore advanced Enterprise features.

[Angular Data Grid quick start video tutorial](https://www.youtube.com/watch?v=X_Ip_jGDtho&list=PLsZlhayVgqNw6VHFn4j6FcJM5vLACsf0x)

> **Note**
>
> The following sections assume a level of familiarity with common Data Grid concepts. If you're new to Angular Data Grids in general, we recommend starting with our [Introductory Tutorial](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/deep-dive/) instead.

## Showing Data

### Mapping Values

The `field` or `valueGetter` attributes [Map Data to Columns](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-definitions/). A field maps to a field in the data. A [Value Getter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-getters/) is a function callback that returns the cell value.

The `headerName` provides the title for the header. If missing the title is derived from `field`.

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    { headerName: "Make & Model", valueGetter: p => p.data.make + ' ' + p.data.model},
    { field: "price" },
];
```

### Text Formatting

Format text for cell content using a [Value Formatter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-formatters/).

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    { field: "price", valueFormatter: p => '£' + p.value.toLocaleString() },
];
```

### Cell Components

Add buttons, checkboxes or images to cells with a [Cell Component](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/component-cell-renderer/).

```js
@Component({
    standalone: true,
    template: `<button (click)="buttonClicked()">Push Me!</button>`,
})
export class CustomButtonComponent implements ICellRendererAngularComp {
    agInit(params: ICellRendererParams): void {}
    refresh(params: ICellRendererParams) {
        return true;
    }
    buttonClicked() {
        alert("clicked");
    }
}

columnDefs: ColDef[] = [
    { field: "button", cellRenderer: CustomButtonComponent },
    // ...
];
```

### Resizing Columns

Columns are [Resized](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-sizing/) by dragging the Column Header edges. Additionally assign `flex` values to allow columns to flex to the grid width.

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    { field: "make", flex: 2 }, //This column will be twice as wide as the others
    { field: "model", flex: 1 },
    { field: "price", flex: 1 },
    { field: "electric", flex: 1 }
];
```

### Example

This example demonstrates mapping and formatting values, cell components, and resizing columns. The button logs to the developer console.

#### Showing Data Example

```ts
import { ChangeDetectionStrategy, Component } from "@angular/core";

import type { ICellRendererAngularComp } from "ag-grid-angular";
import { AgGridAngular } from "ag-grid-angular";
import type {
  ColDef,
  ICellRendererParams,
  ValueGetterParams,
} from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

@Component({
  standalone: true,
  changeDetection: ChangeDetectionStrategy.OnPush,
  template: `<button (click)="buttonClicked()">Push Me!</button>`,
})
export class CustomButtonComponent implements ICellRendererAngularComp {
  agInit(params: ICellRendererParams): void {}
  refresh(params: ICellRendererParams) {
    return true;
  }
  buttonClicked() {
    console.log("clicked");
  }
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: ` <ag-grid-angular
    style="width: 100%; height: 100%;"
    [rowData]="rowData"
    [columnDefs]="columnDefs"
  />`,
})
export class AppComponent {
  public rowData: any[] | null = [
    { make: "Tesla", model: "Model Y", price: 64950, electric: true },
    { make: "Ford", model: "F-Series", price: 33850, electric: false },
    { make: "Toyota", model: "Corolla", price: 29600, electric: false },
    { make: "Mercedes", model: "EQA", price: 48890, electric: true },
    { make: "Fiat", model: "500", price: 15774, electric: false },
    { make: "Nissan", model: "Juke", price: 20675, electric: false },
  ];
  public columnDefs: ColDef[] = [
    {
      headerName: "Make & Model",
      valueGetter: (p: ValueGetterParams) => p.data.make + " " + p.data.model,
      flex: 2,
    },
    {
      field: "price",
      valueFormatter: (p) => "£" + Math.floor(p.value).toLocaleString(),
      flex: 1,
    },
    { field: "electric", flex: 1 },
    { field: "button", cellRenderer: CustomButtonComponent, flex: 1 },
  ];
}
```

[Live example: Showing Data Example](https://www.ag-grid.com/archive/36.2.0/examples/key-features/showing-data-example/angular/)

## Working with Data

By default, the row data is used to infer the [Cell Data Type](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-data-types/). The cell data type allows grid features, such as filtering and editing, to work without additional configuration.

### Filtering

[Column Filters](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filtering/) are embedded into each column menu. These are enabled using the `filter` attribute. The filter type is inferred from the cell data type.

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    { field: "make", filter: true },
];
```

There are 5 [Provided Filters](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filtering/) which can be set through this attribute. You can also create your own [Custom Filter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/component-filter/).

[Floating Filters](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/floating-filters/) embed the Column Filter into the header for ease of access.

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    { field: "make", filter: true, floatingFilter: true },
];
```

### Editing

Enable [Editing](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing/) by setting the `editable` attribute to `true`. The cell editor is inferred from the cell data type.

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    { field: "make", editable: true },
];
```

Set the cell editor type using the `cellEditor` attribute. There are 8 [Provided Cell Editors](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/provided-cell-editors/) which can be set through this attribute. You can also create your own [Custom Editors](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editors/).

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: "make",
        editable: true,
        cellEditor: 'agSelectCellEditor',
        cellEditorParams: {
            values: ['Tesla', 'Ford', 'Toyota'],
        },
    },
];
```

### Sorting

Data is [Sorted](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-sorting/) by clicking the column headers. Sorting is enabled by default.

### Row Selection

[Row Selection](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-selection/) is enabled using the `rowSelection` attribute.

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    [rowSelection]="rowSelection"
    /* other grid options ... */ />

// Column Definitions: Defines the columns to be displayed.
this.columnDefs = [
    { field: "make" },
];
this.rowSelection = {
    mode: 'multiRow',
};
```

### Pagination

Enable [Pagination](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-pagination/) by setting `pagination` to be true.

```ts
<ag-grid-angular
    [pagination]="pagination"
    [paginationPageSize]="paginationPageSize"
    [paginationPageSizeSelector]="paginationPageSizeSelector"
    /* other grid options ... */ />

this.pagination = true;
this.paginationPageSize = 10;
this.paginationPageSizeSelector = [10, 25, 50];
```

### Example

This example demonstrates filtering, editing, sorting, row selection, and pagination.

#### Working With Data Example

```ts
import { Component, ViewChild } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
  AllCommunityModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowSelectionOptions,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [rowData]="rowData"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowSelection]="rowSelection"
    [pagination]="true"
    [paginationPageSize]="paginationPageSize"
    [paginationPageSizeSelector]="paginationPageSizeSelector"
  /> `,
})
export class AppComponent {
  rowData: any[] | null = [
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
  ];
  columnDefs: ColDef[] = [
    {
      field: "make",
      editable: true,
      cellEditor: "agSelectCellEditor",
      cellEditorParams: {
        values: [
          "Tesla",
          "Ford",
          "Toyota",
          "Mercedes",
          "Fiat",
          "Nissan",
          "Vauxhall",
          "Volvo",
          "Jaguar",
        ],
      },
    },
    { field: "model" },
    { field: "price", filter: "agNumberColumnFilter" },
    { field: "electric" },
    {
      field: "month",
      comparator: (valueA, valueB) => {
        const months = [
          "January",
          "February",
          "March",
          "April",
          "May",
          "June",
          "July",
          "August",
          "September",
          "October",
          "November",
          "December",
        ];
        const idxA = months.indexOf(valueA);
        const idxB = months.indexOf(valueB);
        return idxA - idxB;
      },
    },
  ];
  defaultColDef: ColDef = {
    filter: "agTextColumnFilter",
    floatingFilter: true,
  };
  rowSelection: RowSelectionOptions | "single" | "multiple" = {
    mode: "multiRow",
    headerCheckbox: false,
  };
  paginationPageSize = 10;
  paginationPageSizeSelector: number[] | boolean = [10, 25, 50];
}
```

[Live example: Working With Data Example](https://www.ag-grid.com/archive/36.2.0/examples/key-features/working-with-data-example/angular/)

## Themes & Style

### Themes

[Grid Themes](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming/) define how the grid looks (colours, font, spacing etc). The default theme is called Quartz. You can choose a [different theme](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/themes/), or customise a built-in theme by changing parameters. Here we create a new theme based on Quartz:

```js
import { themeQuartz } from "ag-grid-community"; // or themeBalham, themeAlpine

const myTheme = themeQuartz.withParams({
    /* Low spacing = very compact */
    spacing: 2,
    /* Changes the colour of the grid text */
    foregroundColor: 'rgb(14, 68, 145)',
    /* Changes the colour of the grid background */
    backgroundColor: 'rgb(241, 247, 255)',
    /* Changes the header colour of the top row */
    headerBackgroundColor: 'rgb(228, 237, 250)',
    /* Changes the hover colour of the row*/
    rowHoverColor: 'rgb(216, 226, 255)',
});

// ...
    template: `<div style="height: 100%; box-sizing: border-box;">
        <ag-grid-angular
            // ...
            [theme]="theme"
            />
    </div>`,
// ...
public theme = myTheme;
```

#### Customising Quartz Theme

```ts
import { Component, ViewChild } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  AllCommunityModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  Theme,
  enableDevValidations,
  themeQuartz,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [theme]="theme"
    [rowData]="rowData"
    [defaultColDef]="defaultColDef"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 170 },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  theme: Theme | "legacy" = myTheme;
  defaultColDef: ColDef = {
    editable: true,
    filter: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}

const myTheme = themeQuartz.withParams({
  /* Low spacing = very compact */
  spacing: 2,
  /* Changes the colour of the grid text */
  foregroundColor: "rgb(14, 68, 145)",
  /* Changes the colour of the grid background */
  backgroundColor: "rgb(241, 247, 255)",
  /* Changes the header colour of the top row */
  headerBackgroundColor: "rgb(228, 237, 250)",
  /* Changes the hover colour of the row*/
  rowHoverColor: "rgb(216, 226, 255)",
});
```

[Live example: Customising Quartz Theme](https://www.ag-grid.com/archive/36.2.0/examples/key-features/custom-quartz-theme/angular/)

### Theme Builder

Use the [Theme Builder](https://www.ag-grid.com/archive/36.2.0/theme-builder/) to create a custom theme with our visual editor. Browse and customise 100's of theme parameters and preview the changes in real-time. Automatically generate the theme code to copy & paste into your application.

[Video](https://www.ag-grid.com/archive/36.2.0/_astro/theme-builder-demo.DqpCSmGG.mp4)

### Figma

If you are designing within Figma, you can use the [AG Grid Design System](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/ag-grid-design-system/) to replicate the Quartz AG Grid theme within Figma. This default theme can be extended with Figma variables to match any existing visual design or create entirely new AG Grid themes. These can then be exported and generated into new AG Grid themes.

[AG Grid Design System (Figma)](https://www.figma.com/community/file/1360600846643230092/ag-grid-design-system)

### Cell Style

Define rules to apply [Styling to Cells](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-styles/) using `cellClassRules`. This can be used, for example, to set cell background colour based on its value.

```css
.rag-green {
    background-color: #33cc3344;
}
```

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [{
    field: 'electric',
    cellClassRules: {
        // apply green to electric cars
        'rag-green': params => params.value === true,
    }
}];
```

### Row Style

Define rules to apply [Styling to Rows](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-styles/) using `rowClassRules`. This allows changing style (e.g. row colour) based on row values.

```css
.rag-red {
    background-color: #cc222244;
}
```

```ts
<ag-grid-angular
    [rowClassRules]="rowClassRules"
    /* other grid options ... */ />

this.rowClassRules = {
    // apply red to Ford cars
    'rag-red': params => params.data.make === 'Ford',
};
```

### Example

This example demonstrates cell style and row style.

#### Cell and Row Style

```ts
import { Component, ViewChild } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  AllCommunityModule,
  CellClassRules,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowClassRules,
  RowSelectionOptions,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [rowData]="rowData"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowClassRules]="rowClassRules"
    [rowSelection]="rowSelection"
  /> `,
})
export class AppComponent {
  rowData: any[] | null = [
    { make: "Tesla", model: "Model Y", price: 64950, electric: true },
    { make: "Ford", model: "F-Series", price: 33850, electric: false },
    { make: "Toyota", model: "Corolla", price: 29600, electric: false },
    { make: "Mercedes", model: "EQA", price: 48890, electric: true },
    { make: "Fiat", model: "500", price: 15774, electric: false },
    { make: "Nissan", model: "Juke", price: 20675, electric: false },
    { make: "Vauxhall", model: "Corsa", price: 18460, electric: false },
    { make: "Volvo", model: "EX30", price: 33795, electric: true },
    { make: "Mercedes", model: "Maybach", price: 175720, electric: false },
    { make: "Vauxhall", model: "Astra", price: 25795, electric: false },
    { make: "Fiat", model: "Panda", price: 13724, electric: false },
    { make: "Jaguar", model: "I-PACE", price: 69425, electric: true },
  ];
  columnDefs: ColDef[] = [
    {
      field: "make",
    },
    { field: "model" },
    { field: "price", filter: "agNumberColumnFilter" },
    {
      field: "electric",
      cellClassRules: ragCellClassRules,
    },
  ];
  defaultColDef: ColDef = {
    filter: "agTextColumnFilter",
    floatingFilter: true,
    flex: 1,
  };
  rowClassRules: RowClassRules = {
    // apply red to Ford cars
    "rag-red": (params) => params.data.make === "Ford",
  };
  rowSelection: RowSelectionOptions | "single" | "multiple" = {
    mode: "multiRow",
    headerCheckbox: false,
  };
}

const ragCellClassRules: CellClassRules = {
  // apply green to electric cars
  "rag-green": (params) => params.value === true,
};
```

[Live example: Cell and Row Style](https://www.ag-grid.com/archive/36.2.0/examples/key-features/cell-row-style/angular/)

## Enterprise Features  (Enterprise)

AG Grid comes in two forms:

- **AG Grid Community**: Free for everyone, including production use - no licence required.
- **AG Grid Enterprise**: Requires a licence to use in production. Free to test locally, or request a [trial](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/community-vs-enterprise/#request-a-30-day-enterprise-bundle-trial-licence) to test in production.

To learn more about the differences between AG Grid Community and Enterprise, when to use each version, and how to access our [free trial](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/community-vs-enterprise/#request-a-30-day-enterprise-bundle-trial-licence) or purchase a licence, see the [Community vs Enterprise](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/community-vs-enterprise/) docs.

### Integrated Charts  (Enterprise)

[Integrated Charts](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/integrated-charts/) allow users to build and customise charts directly within the grid.

Allow users to create Integrated Charts from the grid UI by setting `enableCharts` to `true`. Set `cellSelection` to `true` to allow users to create charts by selecting a range of cells:

```ts
<ag-grid-angular
    [enableCharts]="enableCharts"
    [cellSelection]="cellSelection"
    /* other grid options ... */ />

this.enableCharts = true;
this.cellSelection = true;
```

### Grouping Rows  (Enterprise)

Enable [Row Grouping](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping/) by setting `rowGroup` to `true`:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    { field: 'country', rowGroup: true },
    // ...
];
```

### Aggregating Rows  (Enterprise)

Enable [Aggregation](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/aggregation/) by setting `aggFunc` to one of `sum`, `min`, `max`, `count`, `avg`, `first`, or `last`:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    { field: 'gold', aggFunc: 'sum' },
    // ...
];
```

### Pivoting Rows  (Enterprise)

Enable [Pivoting](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/pivoting/) by setting `pivotMode` to `true`. Define pivot columns by setting `pivot` to `true`:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    [pivotMode]="pivotMode"
    /* other grid options ... */ />

this.columnDefs = [
    { field: 'sport', pivot: true },
];
this.pivotMode = true;
```

### Displaying Tree Data  (Enterprise)

Tree Data provides a way to supply the grid with structured hierarchical data.

Enable Tree Data by setting `treeData` to `true`. Provide a `getDataPath` callback to configure the [Row Hierarchy](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tree-data-paths/#providing-hierarchy):

```ts
<ag-grid-angular
    [treeData]="treeData"
    [getDataPath]="getDataPath"
    /* other grid options ... */ />

this.treeData = true;
this.getDataPath = data => data.path;
```

### Displaying Tool Panels  (Enterprise)

The grid provides [Tool Panels](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tool-panel/) for [Columns](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tool-panel-columns/) and [Filters](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tool-panel-filters/). You can also provide [Custom Tool Panels](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/component-tool-panel/).

To enable Column and Filter Tool Panels, set `sideBar` to `true`. To display only the Column or Filter Tool Panel, set `sideBar` to `'columns'` or `'filters'`:

```ts
<ag-grid-angular
    [sideBar]="sideBar"
    /* other grid options ... */ />

this.sideBar = true;
```

### Example

This example demonstrates Integrated Charting, Row Grouping, Pivoting, Aggregation and Tool Panels:

#### Enterprise Features

```ts
import { Component, ViewChild } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
  AllCommunityModule,
  CellSelectionOptions,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowGroupingDisplayType,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  AllEnterpriseModule,
  IntegratedChartsModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  AllCommunityModule,
  AllEnterpriseModule,
  IntegratedChartsModule.with(AgChartsEnterpriseModule),
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [rowData]="rowData"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [groupDisplayType]="groupDisplayType"
    [cellSelection]="true"
    [enableCharts]="true"
    [sideBar]="sideBar"
    (firstDataRendered)="onFirstDataRendered($event)"
  /> `,
})
export class AppComponent {
  rowData: any[] | null = [
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
    {
      make: "Tesla",
      model: "Model Y",
      price: 64950,
      electric: true,
      month: "June",
    },
    {
      make: "Ford",
      model: "F-Series",
      price: 33850,
      electric: false,
      month: "October",
    },
    {
      make: "Toyota",
      model: "Corolla",
      price: 29600,
      electric: false,
      month: "August",
    },
    {
      make: "Mercedes",
      model: "EQA",
      price: 48890,
      electric: true,
      month: "February",
    },
    {
      make: "Fiat",
      model: "500",
      price: 15774,
      electric: false,
      month: "January",
    },
    {
      make: "Nissan",
      model: "Juke",
      price: 20675,
      electric: false,
      month: "March",
    },
    {
      make: "Vauxhall",
      model: "Corsa",
      price: 18460,
      electric: false,
      month: "July",
    },
    {
      make: "Volvo",
      model: "EX30",
      price: 33795,
      electric: true,
      month: "September",
    },
    {
      make: "Mercedes",
      model: "Maybach",
      price: 175720,
      electric: false,
      month: "December",
    },
    {
      make: "Vauxhall",
      model: "Astra",
      price: 25795,
      electric: false,
      month: "April",
    },
    {
      make: "Fiat",
      model: "Panda",
      price: 13724,
      electric: false,
      month: "November",
    },
    {
      make: "Jaguar",
      model: "I-PACE",
      price: 69425,
      electric: true,
      month: "May",
    },
  ];
  columnDefs: ColDef[] = [
    // Group by 'make', hiding it once grouped
    { field: "make", rowGroup: true, hide: true },
    { field: "model" },
    // Aggregate the average price per group
    { field: "price", filter: "agNumberColumnFilter", aggFunc: "avg" },
    { field: "electric" },
    { field: "month" },
  ];
  defaultColDef: ColDef = {
    filter: "agTextColumnFilter",
    floatingFilter: true,
    sortable: true,
    resizable: true,
  };
  groupDisplayType: RowGroupingDisplayType = "singleColumn";
  sideBar: SideBarDef | string | string[] | boolean | null = {
    toolPanels: ["columns", "filters"],
    defaultToolPanel: "columns",
  };

  onFirstDataRendered(params) {
    params.api.createRangeChart({
      cellRange: {
        rowStartIndex: 0,
        rowEndIndex: 8,
        columns: ["model", "price"],
      },
      chartType: "groupedColumn",
      chartThemeOverrides: {
        common: {
          title: {
            enabled: true,
            text: "Average Price by Make",
          },
        },
      },
    });
  }
}
```

[Live example: Enterprise Features](https://www.ag-grid.com/archive/36.2.0/examples/key-features/enterprise-features-example/angular/)


---
product: "AG Grid"
title: "Key Features"
description: "Overview of popular AG Grid features with code snippets. Learn how to use key Community features, customise themes and explore advanced Enterprise features."
framework: vue
version: "36.2.0"
related:
    - title: "Quick Start"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/getting-started/"
    - title: "Community vs. Enterprise"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/community-vs-enterprise/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Key Features

The page provides an overview of and introduction to popular features available in AG Grid. Learn how to use Community features, configure and customise themes, and explore advanced Enterprise features.

> **Note**
>
> The following sections assume a level of familiarity with common Data Grid concepts. If you're new to Vue Data Grids in general, we recommend starting with our [Introductory Tutorial](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/deep-dive/) instead.

## Showing Data

### Mapping Values

The `field` or `valueGetter` attributes [Map Data to Columns](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-definitions/). A field maps to a field in the data. A [Value Getter](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/value-getters/) is a function callback that returns the cell value.

The `headerName` provides the title for the header. If missing the title is derived from `field`.

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { headerName: "Make & Model", valueGetter: p => p.data.make + ' ' + p.data.model},
    { field: "price" },
];
```

### Text Formatting

Format text for cell content using a [Value Formatter](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/value-formatters/).

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: "price", valueFormatter: p => '£' + p.value.toLocaleString() },
];
```

### Cell Components

Add buttons, checkboxes or images to cells with a [Cell Component](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/component-cell-renderer/).

```js
// ...
    components: {
        "ag-grid-vue": AgGridVue,
        CustomButtonComponent: {
            template: `
                <button @click="buttonClicked()">Push Me!</button>
            `,
            methods: {
            buttonClicked() {
                alert("clicked");
            },
            },
        },
    },
    data: function () {
        return {
        columnDefs: [
            { field: "button", cellRenderer: CustomButtonComponent },
            // ...
        ],
    };
},
// ...
```

### Resizing Columns

Columns are [Resized](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-sizing/) by dragging the Column Header edges. Additionally assign `flex` values to allow columns to flex to the grid width.

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: "make", flex: 2 }, //This column will be twice as wide as the others
    { field: "model", flex: 1 },
    { field: "price", flex: 1 },
    { field: "electric", flex: 1 }
];
```

### Example

This example demonstrates mapping and formatting values, cell components, and resizing columns. The button logs to the developer console.

#### Showing Data Example

```ts
import { createApp, defineComponent } from "vue";

import type {
  ColDef,
  GridReadyEvent,
  ValueFormatterParams,
  ValueGetterParams,
} from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

const CustomButtonComponent = defineComponent({
  template: `
        <div>        
            <button v-on:click="buttonClicked">Push Me!</button>
        </div>
    `,
  methods: {
    buttonClicked() {
      console.log("clicked");
    },
  },
});

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
            <ag-grid-vue
                style="width: 100%; height: 100%;"
                :columnDefs="columnDefs"
                @grid-ready="onGridReady"
                :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    CustomButtonComponent,
  },
  data: function () {
    return {
      columnDefs: <ColDef[]>[
        {
          headerName: "Make & Model",
          valueGetter: (p: ValueGetterParams) =>
            p.data.make + " " + p.data.model,
          flex: 2,
        },
        {
          field: "price",
          valueFormatter: (p: ValueFormatterParams) =>
            "£" + Math.floor(p.value).toLocaleString(),
          flex: 1,
        },
        {
          field: "electric",
          flex: 1,
        },
        {
          field: "button",
          cellRenderer: "CustomButtonComponent",
          flex: 1,
        },
      ],
      gridApi: null,
      rowData: null,
    };
  },
  created() {
    this.rowData = <any[]>[
      { make: "Tesla", model: "Model Y", price: 64950, electric: true },
      { make: "Ford", model: "F-Series", price: 33850, electric: false },
      { make: "Toyota", model: "Corolla", price: 29600, electric: false },
      { make: "Mercedes", model: "EQA", price: 48890, electric: true },
      { make: "Fiat", model: "500", price: 15774, electric: false },
      { make: "Nissan", model: "Juke", price: 20675, electric: false },
    ];
  },
  methods: {
    onGridReady(params: GridReadyEvent) {
      this.gridApi = params.api;
    },
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Showing Data Example](https://www.ag-grid.com/archive/36.2.0/examples/key-features/showing-data-example/vue3/)

## Working with Data

By default, the row data is used to infer the [Cell Data Type](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-data-types/). The cell data type allows grid features, such as filtering and editing, to work without additional configuration.

### Filtering

[Column Filters](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filtering/) are embedded into each column menu. These are enabled using the `filter` attribute. The filter type is inferred from the cell data type.

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: "make", filter: true },
];
```

There are 5 [Provided Filters](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filtering/) which can be set through this attribute. You can also create your own [Custom Filter](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/component-filter/).

[Floating Filters](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/floating-filters/) embed the Column Filter into the header for ease of access.

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: "make", filter: true, floatingFilter: true },
];
```

### Editing

Enable [Editing](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing/) by setting the `editable` attribute to `true`. The cell editor is inferred from the cell data type.

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: "make", editable: true },
];
```

Set the cell editor type using the `cellEditor` attribute. There are 8 [Provided Cell Editors](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/provided-cell-editors/) which can be set through this attribute. You can also create your own [Custom Editors](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editors/).

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: "make",
        editable: true,
        cellEditor: 'agSelectCellEditor',
        cellEditorParams: {
            values: ['Tesla', 'Ford', 'Toyota'],
        },
    },
];
```

### Sorting

Data is [Sorted](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-sorting/) by clicking the column headers. Sorting is enabled by default.

### Row Selection

[Row Selection](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-selection/) is enabled using the `rowSelection` attribute.

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    :rowSelection="rowSelection"
    /* other grid options ... */>
</ag-grid-vue>

// Column Definitions: Defines the columns to be displayed.
this.columnDefs = [
    { field: "make" },
];
this.rowSelection = {
    mode: 'multiRow',
};
```

### Pagination

Enable [Pagination](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-pagination/) by setting `pagination` to be true.

```ts
<ag-grid-vue
    :pagination="pagination"
    :paginationPageSize="paginationPageSize"
    :paginationPageSizeSelector="paginationPageSizeSelector"
    /* other grid options ... */>
</ag-grid-vue>

this.pagination = true;
this.paginationPageSize = 10;
this.paginationPageSizeSelector = [10, 25, 50];
```

### Example

This example demonstrates filtering, editing, sorting, row selection, and pagination.

#### Working With Data Example

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AllCommunityModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowSelectionOptions,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :rowData="rowData"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :rowSelection="rowSelection"
      :pagination="true"
      :paginationPageSize="paginationPageSize"
      :paginationPageSizeSelector="paginationPageSizeSelector"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const rowData = ref<any[] | null>([
      {
        make: "Tesla",
        model: "Model Y",
        price: 64950,
        electric: true,
        month: "June",
      },
      {
        make: "Ford",
        model: "F-Series",
        price: 33850,
        electric: false,
        month: "October",
      },
      {
        make: "Toyota",
        model: "Corolla",
        price: 29600,
        electric: false,
        month: "August",
      },
      {
        make: "Mercedes",
        model: "EQA",
        price: 48890,
        electric: true,
        month: "February",
      },
      {
        make: "Fiat",
        model: "500",
        price: 15774,
        electric: false,
        month: "January",
      },
      {
        make: "Nissan",
        model: "Juke",
        price: 20675,
        electric: false,
        month: "March",
      },
      {
        make: "Vauxhall",
        model: "Corsa",
        price: 18460,
        electric: false,
        month: "July",
      },
      {
        make: "Volvo",
        model: "EX30",
        price: 33795,
        electric: true,
        month: "September",
      },
      {
        make: "Mercedes",
        model: "Maybach",
        price: 175720,
        electric: false,
        month: "December",
      },
      {
        make: "Vauxhall",
        model: "Astra",
        price: 25795,
        electric: false,
        month: "April",
      },
      {
        make: "Fiat",
        model: "Panda",
        price: 13724,
        electric: false,
        month: "November",
      },
      {
        make: "Jaguar",
        model: "I-PACE",
        price: 69425,
        electric: true,
        month: "May",
      },
      {
        make: "Tesla",
        model: "Model Y",
        price: 64950,
        electric: true,
        month: "June",
      },
      {
        make: "Ford",
        model: "F-Series",
        price: 33850,
        electric: false,
        month: "October",
      },
      {
        make: "Toyota",
        model: "Corolla",
        price: 29600,
        electric: false,
        month: "August",
      },
      {
        make: "Mercedes",
        model: "EQA",
        price: 48890,
        electric: true,
        month: "February",
      },
      {
        make: "Fiat",
        model: "500",
        price: 15774,
        electric: false,
        month: "January",
      },
      {
        make: "Nissan",
        model: "Juke",
        price: 20675,
        electric: false,
        month: "March",
      },
      {
        make: "Vauxhall",
        model: "Corsa",
        price: 18460,
        electric: false,
        month: "July",
      },
      {
        make: "Volvo",
        model: "EX30",
        price: 33795,
        electric: true,
        month: "September",
      },
      {
        make: "Mercedes",
        model: "Maybach",
        price: 175720,
        electric: false,
        month: "December",
      },
      {
        make: "Vauxhall",
        model: "Astra",
        price: 25795,
        electric: false,
        month: "April",
      },
      {
        make: "Fiat",
        model: "Panda",
        price: 13724,
        electric: false,
        month: "November",
      },
      {
        make: "Jaguar",
        model: "I-PACE",
        price: 69425,
        electric: true,
        month: "May",
      },
      {
        make: "Tesla",
        model: "Model Y",
        price: 64950,
        electric: true,
        month: "June",
      },
      {
        make: "Ford",
        model: "F-Series",
        price: 33850,
        electric: false,
        month: "October",
      },
      {
        make: "Toyota",
        model: "Corolla",
        price: 29600,
        electric: false,
        month: "August",
      },
      {
        make: "Mercedes",
        model: "EQA",
        price: 48890,
        electric: true,
        month: "February",
      },
      {
        make: "Fiat",
        model: "500",
        price: 15774,
        electric: false,
        month: "January",
      },
      {
        make: "Nissan",
        model: "Juke",
        price: 20675,
        electric: false,
        month: "March",
      },
      {
        make: "Vauxhall",
        model: "Corsa",
        price: 18460,
        electric: false,
        month: "July",
      },
      {
        make: "Volvo",
        model: "EX30",
        price: 33795,
        electric: true,
        month: "September",
      },
      {
        make: "Mercedes",
        model: "Maybach",
        price: 175720,
        electric: false,
        month: "December",
      },
      {
        make: "Vauxhall",
        model: "Astra",
        price: 25795,
        electric: false,
        month: "April",
      },
      {
        make: "Fiat",
        model: "Panda",
        price: 13724,
        electric: false,
        month: "November",
      },
      {
        make: "Jaguar",
        model: "I-PACE",
        price: 69425,
        electric: true,
        month: "May",
      },
    ]);
    const columnDefs = ref<ColDef[]>([
      {
        field: "make",
        editable: true,
        cellEditor: "agSelectCellEditor",
        cellEditorParams: {
          values: [
            "Tesla",
            "Ford",
            "Toyota",
            "Mercedes",
            "Fiat",
            "Nissan",
            "Vauxhall",
            "Volvo",
            "Jaguar",
          ],
        },
      },
      { field: "model" },
      { field: "price", filter: "agNumberColumnFilter" },
      { field: "electric" },
      {
        field: "month",
        comparator: (valueA, valueB) => {
          const months = [
            "January",
            "February",
            "March",
            "April",
            "May",
            "June",
            "July",
            "August",
            "September",
            "October",
            "November",
            "December",
          ];
          const idxA = months.indexOf(valueA);
          const idxB = months.indexOf(valueB);
          return idxA - idxB;
        },
      },
    ]);
    const defaultColDef = ref<ColDef>({
      filter: "agTextColumnFilter",
      floatingFilter: true,
    });
    const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
      mode: "multiRow",
      headerCheckbox: false,
    });
    const paginationPageSize = ref(10);
    const paginationPageSizeSelector = ref<number[] | boolean>([10, 25, 50]);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      rowData,
      columnDefs,
      defaultColDef,
      rowSelection,
      paginationPageSize,
      paginationPageSizeSelector,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Working With Data Example](https://www.ag-grid.com/archive/36.2.0/examples/key-features/working-with-data-example/vue3/)

## Themes & Style

### Themes

[Grid Themes](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming/) define how the grid looks (colours, font, spacing etc). The default theme is called Quartz. You can choose a [different theme](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/themes/), or customise a built-in theme by changing parameters. Here we create a new theme based on Quartz:

```js
import { themeQuartz } from "ag-grid-community"; // or themeBalham, themeAlpine

const myTheme = themeQuartz.withParams({
    /* Low spacing = very compact */
    spacing: 2,
    /* Changes the colour of the grid text */
    foregroundColor: 'rgb(14, 68, 145)',
    /* Changes the colour of the grid background */
    backgroundColor: 'rgb(241, 247, 255)',
    /* Changes the header colour of the top row */
    headerBackgroundColor: 'rgb(228, 237, 250)',
    /* Changes the hover colour of the row*/
    rowHoverColor: 'rgb(216, 226, 255)',
});

const VueExample = {
    template: `
        <div style="height: 100%">
            <div style="height: 100%; box-sizing: border-box;">
                <ag-grid-vue
                // ...
                :theme="theme"></ag-grid-vue>
            </div>
        </div>
    `,
// ...
 data: function () {
    return {
        // ...
        theme: myTheme,
    };
 },
// ...
```

#### Customising Quartz Theme

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AllCommunityModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  Theme,
  enableDevValidations,
  themeQuartz,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

const myTheme = themeQuartz.withParams({
  /* Low spacing = very compact */
  spacing: 2,
  /* Changes the colour of the grid text */
  foregroundColor: "rgb(14, 68, 145)",
  /* Changes the colour of the grid background */
  backgroundColor: "rgb(241, 247, 255)",
  /* Changes the header colour of the top row */
  headerBackgroundColor: "rgb(228, 237, 250)",
  /* Changes the hover colour of the row*/
  rowHoverColor: "rgb(216, 226, 255)",
});

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :theme="theme"
      :rowData="rowData"
      :defaultColDef="defaultColDef"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 170 },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const theme = ref<Theme | "legacy">(myTheme);
    const defaultColDef = ref<ColDef>({
      editable: true,
      filter: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      theme,
      rowData,
      defaultColDef,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Customising Quartz Theme](https://www.ag-grid.com/archive/36.2.0/examples/key-features/custom-quartz-theme/vue3/)

### Theme Builder

Use the [Theme Builder](https://www.ag-grid.com/archive/36.2.0/theme-builder/) to create a custom theme with our visual editor. Browse and customise 100's of theme parameters and preview the changes in real-time. Automatically generate the theme code to copy & paste into your application.

[Video](https://www.ag-grid.com/archive/36.2.0/_astro/theme-builder-demo.DqpCSmGG.mp4)

### Figma

If you are designing within Figma, you can use the [AG Grid Design System](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/ag-grid-design-system/) to replicate the Quartz AG Grid theme within Figma. This default theme can be extended with Figma variables to match any existing visual design or create entirely new AG Grid themes. These can then be exported and generated into new AG Grid themes.

[AG Grid Design System (Figma)](https://www.figma.com/community/file/1360600846643230092/ag-grid-design-system)

### Cell Style

Define rules to apply [Styling to Cells](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-styles/) using `cellClassRules`. This can be used, for example, to set cell background colour based on its value.

```css
.rag-green {
    background-color: #33cc3344;
}
```

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [{
    field: 'electric',
    cellClassRules: {
        // apply green to electric cars
        'rag-green': params => params.value === true,
    }
}];
```

### Row Style

Define rules to apply [Styling to Rows](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-styles/) using `rowClassRules`. This allows changing style (e.g. row colour) based on row values.

```css
.rag-red {
    background-color: #cc222244;
}
```

```ts
<ag-grid-vue
    :rowClassRules="rowClassRules"
    /* other grid options ... */>
</ag-grid-vue>

this.rowClassRules = {
    // apply red to Ford cars
    'rag-red': params => params.data.make === 'Ford',
};
```

### Example

This example demonstrates cell style and row style.

#### Cell and Row Style

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  AllCommunityModule,
  CellClassRules,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowClassRules,
  RowSelectionOptions,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

const ragCellClassRules: CellClassRules = {
  // apply green to electric cars
  "rag-green": (params) => params.value === true,
};

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :rowData="rowData"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :rowClassRules="rowClassRules"
      :rowSelection="rowSelection"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const rowData = ref<any[] | null>([
      { make: "Tesla", model: "Model Y", price: 64950, electric: true },
      { make: "Ford", model: "F-Series", price: 33850, electric: false },
      { make: "Toyota", model: "Corolla", price: 29600, electric: false },
      { make: "Mercedes", model: "EQA", price: 48890, electric: true },
      { make: "Fiat", model: "500", price: 15774, electric: false },
      { make: "Nissan", model: "Juke", price: 20675, electric: false },
      { make: "Vauxhall", model: "Corsa", price: 18460, electric: false },
      { make: "Volvo", model: "EX30", price: 33795, electric: true },
      { make: "Mercedes", model: "Maybach", price: 175720, electric: false },
      { make: "Vauxhall", model: "Astra", price: 25795, electric: false },
      { make: "Fiat", model: "Panda", price: 13724, electric: false },
      { make: "Jaguar", model: "I-PACE", price: 69425, electric: true },
    ]);
    const columnDefs = ref<ColDef[]>([
      {
        field: "make",
      },
      { field: "model" },
      { field: "price", filter: "agNumberColumnFilter" },
      {
        field: "electric",
        cellClassRules: ragCellClassRules,
      },
    ]);
    const defaultColDef = ref<ColDef>({
      filter: "agTextColumnFilter",
      floatingFilter: true,
      flex: 1,
    });
    const rowClassRules = ref<RowClassRules>({
      // apply red to Ford cars
      "rag-red": (params) => params.data.make === "Ford",
    });
    const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
      mode: "multiRow",
      headerCheckbox: false,
    });

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      rowData,
      columnDefs,
      defaultColDef,
      rowClassRules,
      rowSelection,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Cell and Row Style](https://www.ag-grid.com/archive/36.2.0/examples/key-features/cell-row-style/vue3/)

## Enterprise Features  (Enterprise)

AG Grid comes in two forms:

- **AG Grid Community**: Free for everyone, including production use - no licence required.
- **AG Grid Enterprise**: Requires a licence to use in production. Free to test locally, or request a [trial](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/community-vs-enterprise/#request-a-30-day-enterprise-bundle-trial-licence) to test in production.

To learn more about the differences between AG Grid Community and Enterprise, when to use each version, and how to access our [free trial](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/community-vs-enterprise/#request-a-30-day-enterprise-bundle-trial-licence) or purchase a licence, see the [Community vs Enterprise](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/community-vs-enterprise/) docs.

### Integrated Charts  (Enterprise)

[Integrated Charts](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/integrated-charts/) allow users to build and customise charts directly within the grid.

Allow users to create Integrated Charts from the grid UI by setting `enableCharts` to `true`. Set `cellSelection` to `true` to allow users to create charts by selecting a range of cells:

```ts
<ag-grid-vue
    :enableCharts="enableCharts"
    :cellSelection="cellSelection"
    /* other grid options ... */>
</ag-grid-vue>

this.enableCharts = true;
this.cellSelection = true;
```

### Grouping Rows  (Enterprise)

Enable [Row Grouping](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping/) by setting `rowGroup` to `true`:

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: 'country', rowGroup: true },
    // ...
];
```

### Aggregating Rows  (Enterprise)

Enable [Aggregation](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/aggregation/) by setting `aggFunc` to one of `sum`, `min`, `max`, `count`, `avg`, `first`, or `last`:

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: 'gold', aggFunc: 'sum' },
    // ...
];
```

### Pivoting Rows  (Enterprise)

Enable [Pivoting](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/pivoting/) by setting `pivotMode` to `true`. Define pivot columns by setting `pivot` to `true`:

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    :pivotMode="pivotMode"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: 'sport', pivot: true },
];
this.pivotMode = true;
```

### Displaying Tree Data  (Enterprise)

Tree Data provides a way to supply the grid with structured hierarchical data.

Enable Tree Data by setting `treeData` to `true`. Provide a `getDataPath` callback to configure the [Row Hierarchy](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tree-data-paths/#providing-hierarchy):

```ts
<ag-grid-vue
    :treeData="treeData"
    :getDataPath="getDataPath"
    /* other grid options ... */>
</ag-grid-vue>

this.treeData = true;
this.getDataPath = data => data.path;
```

### Displaying Tool Panels  (Enterprise)

The grid provides [Tool Panels](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tool-panel/) for [Columns](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tool-panel-columns/) and [Filters](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tool-panel-filters/). You can also provide [Custom Tool Panels](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/component-tool-panel/).

To enable Column and Filter Tool Panels, set `sideBar` to `true`. To display only the Column or Filter Tool Panel, set `sideBar` to `'columns'` or `'filters'`:

```ts
<ag-grid-vue
    :sideBar="sideBar"
    /* other grid options ... */>
</ag-grid-vue>

this.sideBar = true;
```

### Example

This example demonstrates Integrated Charting, Row Grouping, Pivoting, Aggregation and Tool Panels:

#### Enterprise Features

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
  AllCommunityModule,
  CellSelectionOptions,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowGroupingDisplayType,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  AllEnterpriseModule,
  IntegratedChartsModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  AllCommunityModule,
  AllEnterpriseModule,
  IntegratedChartsModule.with(AgChartsEnterpriseModule),
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :rowData="rowData"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :groupDisplayType="groupDisplayType"
      :cellSelection="true"
      :enableCharts="true"
      :sideBar="sideBar"
      @first-data-rendered="onFirstDataRendered"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const rowData = ref<any[] | null>([
      {
        make: "Tesla",
        model: "Model Y",
        price: 64950,
        electric: true,
        month: "June",
      },
      {
        make: "Ford",
        model: "F-Series",
        price: 33850,
        electric: false,
        month: "October",
      },
      {
        make: "Toyota",
        model: "Corolla",
        price: 29600,
        electric: false,
        month: "August",
      },
      {
        make: "Mercedes",
        model: "EQA",
        price: 48890,
        electric: true,
        month: "February",
      },
      {
        make: "Fiat",
        model: "500",
        price: 15774,
        electric: false,
        month: "January",
      },
      {
        make: "Nissan",
        model: "Juke",
        price: 20675,
        electric: false,
        month: "March",
      },
      {
        make: "Vauxhall",
        model: "Corsa",
        price: 18460,
        electric: false,
        month: "July",
      },
      {
        make: "Volvo",
        model: "EX30",
        price: 33795,
        electric: true,
        month: "September",
      },
      {
        make: "Mercedes",
        model: "Maybach",
        price: 175720,
        electric: false,
        month: "December",
      },
      {
        make: "Vauxhall",
        model: "Astra",
        price: 25795,
        electric: false,
        month: "April",
      },
      {
        make: "Fiat",
        model: "Panda",
        price: 13724,
        electric: false,
        month: "November",
      },
      {
        make: "Jaguar",
        model: "I-PACE",
        price: 69425,
        electric: true,
        month: "May",
      },
      {
        make: "Tesla",
        model: "Model Y",
        price: 64950,
        electric: true,
        month: "June",
      },
      {
        make: "Ford",
        model: "F-Series",
        price: 33850,
        electric: false,
        month: "October",
      },
      {
        make: "Toyota",
        model: "Corolla",
        price: 29600,
        electric: false,
        month: "August",
      },
      {
        make: "Mercedes",
        model: "EQA",
        price: 48890,
        electric: true,
        month: "February",
      },
      {
        make: "Fiat",
        model: "500",
        price: 15774,
        electric: false,
        month: "January",
      },
      {
        make: "Nissan",
        model: "Juke",
        price: 20675,
        electric: false,
        month: "March",
      },
      {
        make: "Vauxhall",
        model: "Corsa",
        price: 18460,
        electric: false,
        month: "July",
      },
      {
        make: "Volvo",
        model: "EX30",
        price: 33795,
        electric: true,
        month: "September",
      },
      {
        make: "Mercedes",
        model: "Maybach",
        price: 175720,
        electric: false,
        month: "December",
      },
      {
        make: "Vauxhall",
        model: "Astra",
        price: 25795,
        electric: false,
        month: "April",
      },
      {
        make: "Fiat",
        model: "Panda",
        price: 13724,
        electric: false,
        month: "November",
      },
      {
        make: "Jaguar",
        model: "I-PACE",
        price: 69425,
        electric: true,
        month: "May",
      },
      {
        make: "Tesla",
        model: "Model Y",
        price: 64950,
        electric: true,
        month: "June",
      },
      {
        make: "Ford",
        model: "F-Series",
        price: 33850,
        electric: false,
        month: "October",
      },
      {
        make: "Toyota",
        model: "Corolla",
        price: 29600,
        electric: false,
        month: "August",
      },
      {
        make: "Mercedes",
        model: "EQA",
        price: 48890,
        electric: true,
        month: "February",
      },
      {
        make: "Fiat",
        model: "500",
        price: 15774,
        electric: false,
        month: "January",
      },
      {
        make: "Nissan",
        model: "Juke",
        price: 20675,
        electric: false,
        month: "March",
      },
      {
        make: "Vauxhall",
        model: "Corsa",
        price: 18460,
        electric: false,
        month: "July",
      },
      {
        make: "Volvo",
        model: "EX30",
        price: 33795,
        electric: true,
        month: "September",
      },
      {
        make: "Mercedes",
        model: "Maybach",
        price: 175720,
        electric: false,
        month: "December",
      },
      {
        make: "Vauxhall",
        model: "Astra",
        price: 25795,
        electric: false,
        month: "April",
      },
      {
        make: "Fiat",
        model: "Panda",
        price: 13724,
        electric: false,
        month: "November",
      },
      {
        make: "Jaguar",
        model: "I-PACE",
        price: 69425,
        electric: true,
        month: "May",
      },
    ]);
    const columnDefs = ref<ColDef[]>([
      // Group by 'make', hiding it once grouped
      { field: "make", rowGroup: true, hide: true },
      { field: "model" },
      // Aggregate the average price per group
      { field: "price", filter: "agNumberColumnFilter", aggFunc: "avg" },
      { field: "electric" },
      { field: "month" },
    ]);
    const defaultColDef = ref<ColDef>({
      filter: "agTextColumnFilter",
      floatingFilter: true,
      sortable: true,
      resizable: true,
    });
    const groupDisplayType = ref<RowGroupingDisplayType>("singleColumn");
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>({
      toolPanels: ["columns", "filters"],
      defaultToolPanel: "columns",
    });

    function onFirstDataRendered(params) {
      params.api.createRangeChart({
        cellRange: {
          rowStartIndex: 0,
          rowEndIndex: 8,
          columns: ["model", "price"],
        },
        chartType: "groupedColumn",
        chartThemeOverrides: {
          common: {
            title: {
              enabled: true,
              text: "Average Price by Make",
            },
          },
        },
      });
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      rowData,
      columnDefs,
      defaultColDef,
      groupDisplayType,
      sideBar,
      onGridReady,
      onFirstDataRendered,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Enterprise Features](https://www.ag-grid.com/archive/36.2.0/examples/key-features/enterprise-features-example/vue3/)
